// Precision
precision highp float;

varying vec4 DestinationColor;

float randomNoise(vec2 p) {
    return fract(6791.*sin(47.*p.x+p.y*9973.));
}

float smoothNoise(vec2 p) {
    vec2 nn = vec2(p.x, p.y+1.);
    vec2 ee = vec2(p.x+1., p.y);
    vec2 ss = vec2(p.x, p.y-1.);
    vec2 ww = vec2(p.x-1., p.y);
    vec2 cc = vec2(p.x, p.y);
    
    float sum = 0.;
    sum += randomNoise(nn)/8.;
    sum += randomNoise(ee)/8.;
    sum += randomNoise(ss)/8.;
    sum += randomNoise(ww)/8.;
    sum += randomNoise(cc)/2.;
    
    return sum;
}

void main(void) {
    vec2 position = gl_FragCoord.xy/vec2(768.0, 1024.0);
    float luminosity = 0.299 * DestinationColor.r + 0.587 * DestinationColor.g + 0.114 * DestinationColor.b;
    float noise = (smoothNoise(position) - 0.5) * 0.14 * (1.0 - luminosity * 1.06);
    gl_FragColor = DestinationColor + vec4(vec3(noise), 0.0);
}