#  Copyright (c) 2015-2016 PSPDFKit GmbH. All rights reserved.
#
#  THIS SOURCE CODE AND ANY ACCOMPANYING DOCUMENTATION ARE PROTECTED BY INTERNATIONAL COPYRIGHT LAW
#  AND MAY NOT BE RESOLD OR REDISTRIBUTED. USAGE IS BOUND TO THE PSPDFKIT LICENSE AGREEMENT.
#  UNAUTHORIZED REPRODUCTION OR DISTRIBUTION IS SUBJECT TO CIVIL AND CRIMINAL PENALTIES.
#  This notice may not be removed from this file.

function codesign {
    echo "Code signing $1 using identity \"$EXPANDED_CODE_SIGN_IDENTITY_NAME\""
    /usr/bin/codesign --force --sign "$EXPANDED_CODE_SIGN_IDENTITY" --preserve-metadata=identifier,entitlements "$1"
}

function strip_binary {
    binary="$1"
    archs=$(lipo -info "$binary" | rev | cut -d ':' -f1 | rev)
    stripped_archs=""
    for arch in $archs; do
        if [[ "$VALID_ARCHS" != *"$arch"* ]]; then
            # Remove unneeded slices
            lipo -remove "$arch" -output "$binary" "$binary" || exit 1
            stripped_archs="$stripped_archs $arch"
        fi
    done
    echo "$stripped_archs"
}

if [ "$SCRIPT_INPUT_FILE_COUNT" -gt 1 ]; then
  echo "Only one dSYM folder as input file allowed"
  exit 1
fi

cd "$BUILT_PRODUCTS_DIR/$FRAMEWORKS_FOLDER_PATH"
framework_folder="./EDAM.framework"

framework="$framework_folder/EDAM"
# No need to strip static libraries
if [[ $(file "$framework") != *"dynamically linked shared library"* ]]; then
    exit 0
fi

stripped_framework_archs=$(strip_binary "$framework")

if [[ -n "$stripped_framework_archs" ]]; then
    echo "Removed the following architectures from EDAM framework: $stripped_framework_archs"
    if [ "$CODE_SIGNING_REQUIRED" == "YES" ]; then
        codesign "$framework"
    fi
fi
